## putty 0.60+2010-12

=== macosx/Makefile ===
# Makefile for putty under Mac OS X.
#
# This file was created by `mkfiles.pl' from the `Recipe' file.
# DO NOT EDIT THIS FILE DIRECTLY; edit Recipe or mkfiles.pl instead.
#
# Extra options you can set:
#
#  - VER="-DSNAPSHOT=1999-01-25 -DSVN_REV=1234"
#      Generates executables whose About box report them as being a
#      development snapshot. SVN_REV is a Subversion revision number.
#
#  - VER=-DRELEASE=0.43
#      Generates executables whose About box report them as being a
#      release version.
#
#  - COMPAT=-DAUTO_WINSOCK (Windows only)
#      Causes PuTTY to assume that <windows.h> includes its own WinSock
#      header file, so that it won't try to include <winsock.h>.
#
#  - COMPAT=-DWINSOCK_TWO (Windows only)
#      Causes the PuTTY utilities to include <winsock2.h> instead of
#      <winsock.h>, except Plink which _needs_ WinSock 2 so it already
#      does this.
#
#  - COMPAT=-DNO_SECURITY (Windows only)
#      Disables Pageant's use of <aclapi.h>, which is not available
#      with some development environments (such as older versions of
#      the Cygwin/mingw GNU toolchain). This means that Pageant
#      won't care about the local user ID of processes accessing it; a
#      version of Pageant built with this option will therefore refuse
#      to run under NT-series OSes on security grounds (although it
#      will run fine on Win95-series OSes where there is no access
#      control anyway).
#
#  - COMPAT=-DNO_MULTIMON (Windows only)
#      Disables PuTTY's use of <multimon.h>, which is not available
#      with some development environments. This means that PuTTY's
#      full-screen mode (configurable to work on Alt-Enter) will
#      not behave usefully in a multi-monitor environment.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <multimon.h> is
#      known not to be available in Cygwin.
#
#  - COMPAT=-DNO_HTMLHELP (Windows only)
#      Disables PuTTY's use of <htmlhelp.h>, which is not available
#      with some development environments. The resulting binary
#      will only look for an old-style WinHelp file (.HLP/.CNT), and
#      will ignore any .CHM file.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <htmlhelp.h> is
#      known not to be available in Cygwin (although you can use
#      the htmlhelp.h supplied with HTML Help Workshop).
#
#  - RCFL=-DNO_MANIFESTS (Windows only)
#      Disables inclusion of XML application manifests in the PuTTY
#      binaries. This may be necessary to build for 64-bit Windows;
#      the manifests are only included to use the XP GUI style on
#      Windows XP, and the architecture tags are a lie on 64-bit.
#
#  - COMPAT=-DNO_IPV6
#      Disables PuTTY's ability to make IPv6 connections, enabling
#      it to compile under development environments which do not
#      support IPv6 in their header files.
#
#  - COMPAT=-DNO_GSSAPI
#      Disables PuTTY's ability to use GSSAPI functions for
#      authentication and key exchange.
#
#  - COMPAT=-DSTATIC_GSSAPI
#      Causes PuTTY to try to link statically against the GSSAPI
#      library instead of the default of doing it at run time.
#
#  - COMPAT=-DMSVC4 (Windows only)
#  - RCFL=-DMSVC4
#      Makes a couple of minor changes so that PuTTY compiles using
#      MSVC 4. You will also need -DNO_SECURITY and -DNO_MULTIMON.
#
#  - RCFL=-DASCIICTLS (Windows only)
#      Uses ASCII rather than Unicode to specify the tab control in
#      the resource file. Probably most useful when compiling with
#      Cygnus/mingw32, whose resource compiler may have less of a
#      problem with it.
#
#  - XFLAGS=-DTELNET_DEFAULT
#      Causes PuTTY to default to the Telnet protocol (in the absence
#      of Default Settings and so on to the contrary). Normally PuTTY
#      will default to SSH.
#
#  - XFLAGS=-DDEBUG
#      Causes PuTTY to enable internal debugging.
#
#  - XFLAGS=-DMALLOC_LOG
#      Causes PuTTY to emit a file called putty_mem.log, logging every
#      memory allocation and free, so you can track memory leaks.
#
#  - XFLAGS=-DMINEFIELD (Windows only)
#      Causes PuTTY to use a custom memory allocator, similar in
#      concept to Electric Fence, in place of regular malloc(). Wastes
#      huge amounts of RAM, but should cause heap-corruption bugs to
#      show up as GPFs at the point of failure rather than appearing
#      later on as second-level damage.
#
CC = $(TOOLPATH)gcc

CFLAGS = -O2 -Wall -Werror -g -I.././ -I../charset/ -I../windows/ -I../unix/ \
		-I../macosx/
MLDFLAGS = -framework Cocoa
ULDFLAGS =

CFLAGS += -DMACOSX

all: PuTTY plink pscp psftp puttygen
PuTTY.app:
	mkdir -p $@
PuTTY.app/Contents: PuTTY.app
	mkdir -p $@
PuTTY.app/Contents/MacOS: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources/PuTTY.icns: PuTTY.app/Contents/Resources putty.icns
	cp putty.icns $@
PuTTY.app/Contents/Info.plist: PuTTY.app/Contents/Resources info.plist
	cp info.plist $@
PuTTY: PuTTY.app/Contents/MacOS/PuTTY \
		PuTTY.app/Contents/Resources/PuTTY.icns \
		PuTTY.app/Contents/Info.plist $(PuTTY_extra)

PuTTY.app/Contents/MacOS/PuTTY: PuTTY.app/Contents/MacOS be_all_s.o config.o \
		cproxy.o dialog.o fromucs.o ldisc.o ldiscucs.o localenc.o \
		logging.o macenc.o mimeenc.o minibidi.o misc.o osxctrls.o \
		osxdlg.o osxmain.o osxsel.o osxwin.o pgssapi.o pinger.o \
		portfwd.o proxy.o raw.o rlogin.o sbcs.o sbcsdat.o sercfg.o \
		settings.o slookup.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o \
		sshsh512.o sshsha.o sshzlib.o telnet.o terminal.o testback.o \
		time.o timing.o toucs.o tree234.o utf8.o ux_x11.o uxagentc.o \
		uxcfg.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxprint.o \
		uxproxy.o uxpty.o uxsel.o uxser.o uxsignal.o uxstore.o \
		uxucs.o version.o wcwidth.o wildcard.o x11fwd.o xenc.o
	$(CC) $(MLDFLAGS) -o $@ be_all_s.o config.o cproxy.o dialog.o \
		fromucs.o ldisc.o ldiscucs.o localenc.o logging.o macenc.o \
		mimeenc.o minibidi.o misc.o osxctrls.o osxdlg.o osxmain.o \
		osxsel.o osxwin.o pgssapi.o pinger.o portfwd.o proxy.o raw.o \
		rlogin.o sbcs.o sbcsdat.o sercfg.o settings.o slookup.o \
		ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o \
		sshcrcda.o sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o \
		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
		sshzlib.o telnet.o terminal.o testback.o time.o timing.o \
		toucs.o tree234.o utf8.o ux_x11.o uxagentc.o uxcfg.o uxgss.o \
		uxmisc.o uxnet.o uxnoise.o uxprint.o uxproxy.o uxpty.o \
		uxsel.o uxser.o uxsignal.o uxstore.o uxucs.o version.o \
		wcwidth.o wildcard.o x11fwd.o xenc.o 

plink: be_all_s.o cmdline.o cproxy.o ldisc.o logging.o misc.o pgssapi.o \
		pinger.o portfwd.o proxy.o raw.o rlogin.o settings.o ssh.o \
		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o sshzlib.o \
		telnet.o time.o timing.o tree234.o ux_x11.o uxagentc.o \
		uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxplink.o \
		uxproxy.o uxsel.o uxser.o uxsignal.o uxstore.o version.o \
		wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_all_s.o cmdline.o cproxy.o ldisc.o \
		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o raw.o \
		rlogin.o settings.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o \
		sshsh512.o sshsha.o sshzlib.o telnet.o time.o timing.o \
		tree234.o ux_x11.o uxagentc.o uxcons.o uxgss.o uxmisc.o \
		uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o uxser.o \
		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o 

pscp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
		pinger.o portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o \
		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o sshzlib.o \
		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
		uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o uxsftp.o \
		uxstore.o version.o wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o pscp.o \
		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o \
		sshsh512.o sshsha.o sshzlib.o time.o timing.o tree234.o \
		uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o \
		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
		x11fwd.o 

psftp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
		pinger.o portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o \
		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o sshzlib.o \
		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
		uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o uxsftp.o \
		uxstore.o version.o wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o \
		psftp.o settings.o sftp.o ssh.o sshaes.o ssharcf.o \
		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
		sshdss.o sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
		sshsh256.o sshsh512.o sshsha.o sshzlib.o time.o timing.o \
		tree234.o uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o \
		uxnoise.o uxproxy.o uxsel.o uxsftp.o uxstore.o version.o \
		wildcard.o x11fwd.o 

puttygen: cmdgen.o import.o misc.o notiming.o sshaes.o sshbn.o sshdes.o \
		sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o sshrand.o \
		sshrsa.o sshrsag.o sshsh256.o sshsh512.o sshsha.o time.o \
		tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o uxstore.o \
		version.o
	$(CC) $(ULDFLAGS) -o $@ cmdgen.o import.o misc.o notiming.o sshaes.o \
		sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o \
		sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh256.o sshsh512.o \
		sshsha.o time.o tree234.o uxcons.o uxgen.o uxmisc.o \
		uxnoise.o uxstore.o version.o 

be_all_s.o: ../be_all_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
be_none.o: ../be_none.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
be_nos_s.o: ../be_nos_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \
		../misc.h ../puttymem.h ../tree234.h ../int64.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
cmdline.o: ../cmdline.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
config.o: ../config.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
		../network.h ../misc.h ../windows/winstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<

## putty 0.60+2010-12-08

=== debian/changelog ===
putty (0.60+2010-12-08-1) unstable; urgency=low

  * New experimental development snapshot.
    - Add more possible baud rates to the Unix serial backend (closes:
      #606328).
  * Add ${misc:Depends}.
  * Remove deprecated Encoding keys from desktop files.
  * Remove deprecated Application categories from desktop files.
  * Build with GSSAPI support (using run-time library binding).

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Dec 2010 17:54:50 +0000

=== debian/control ===
Source: putty
Section: net
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 3.5.9
Build-Depends: debhelper (>= 7.0.50), pkg-config, libgtk2.0-dev, x11proto-core-dev, libx11-dev, imagemagick, python
Vcs-Bzr: http://bzr.debian.org/pkg-ssh/putty/trunk
Vcs-Browser: http://bzr.debian.org/loggerhead/pkg-ssh/putty/trunk

Package: pterm
Section: x11
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: putty-doc
Provides: x-terminal-emulator
Description: PuTTY terminal emulator
 This is an X terminal emulator based on the popular Windows ssh client,
 PuTTY. It supports xterm escape sequences, plus some Linux console
 sequences for colour palette configuration and some DECterm sequences for
 title bar control, and with an appropriate font it supports the UTF-8
 encoding of Unicode. It also has some nifty features like rectangular
 selection and NetHack keypad mode.

Package: putty
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, putty-tools
Suggests: putty-doc
Description: Telnet/SSH client for X
 This is the Unix port of the popular Windows ssh client, PuTTY. It supports
 flexible terminal setup, mid-session reconfiguration using Ctrl-rightclick,
 multiple X11 authentication protocols, and various other interesting things
 not provided by ssh in an xterm.

Package: putty-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: putty-doc
Description: command-line tools for SSH, SCP, and SFTP
 This package provides four command-line tools from the PuTTY suite that
 allow various kinds of secure interaction with remote systems.
 .
 Plink (PuTTY Link) connects to a remote system via SSH, Telnet, or rlogin,
 and either starts an interactive session or runs a batch process. It
 supports the usual SSH features like port forwarding, X11 forwarding,
 SOCKS, and compression.
 .
 PSCP (PuTTY Secure Copy) transfers files securely between systems using an
 SSH connection. It works with both SSH protocol 1 and protocol 2.
 .
 PSFTP (PuTTY SFTP client) transfers files securely between systems using
 the SSH file transfer protocol, which is specific to SSH protocol 2. In
 interactive mode its interface is much like the traditional Unix FTP
 client, although it can also operate in batch mode.
 .
 PuTTYgen generates SSH public and private key pairs in any of a number of
 formats, including those usable by PuTTY, OpenSSH, and ssh.com.
 .
 All these utilities can make use of PuTTY's saved sessions where
 appropriate.

Package: putty-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: PuTTY HTML documentation
 Full HTML documentation for the PuTTY suite of programs (PuTTY, pterm,
 Plink, PSCP, PSFTP, and PuTTYgen).

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@

ptermtmp = debian/pterm
puttytmp = debian/putty

version := $(shell dpkg-parsechangelog | grep '^Version:' | \
		   sed -e 's/.*\([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]\).*/\1/')

# If a snapshot, supply an explicit version. Release tarballs work it out
# for themselves.
ifeq (,$(findstring Version,$(version)))
verdef := VER=-DSNAPSHOT="$(version)"
endif

override_dh_auto_build:
	cd unix && $(MAKE) -f Makefile.gtk $(verdef) \
		plink pscp psftp pterm putty puttygen
	$(MAKE) -C icons cicons pngs

override_dh_auto_clean:
	cd unix && $(MAKE) -f Makefile.gtk clean
	$(MAKE) -C icons clean

override_dh_install:
	dh_install
	install -m644 icons/xpmpterm.c $(ptermtmp)/usr/share/pixmaps/pterm.xpm
	install -m644 icons/xpmputty.c $(puttytmp)/usr/share/pixmaps/putty.xpm
	install -m644 icons/pterm-32.png \
		      $(ptermtmp)/usr/share/pixmaps/pterm.png
	install -m644 icons/putty-32.png \
		      $(puttytmp)/usr/share/pixmaps/putty.png

override_dh_compress:
	dh_compress -X.py

override_dh_fixperms:
	dh_fixperms
	chgrp utmp $(ptermtmp)/usr/bin/pterm
	chmod g+s $(ptermtmp)/usr/bin/pterm

## putty 0.61

=== debian/changelog ===
putty (0.61-2) unstable; urgency=low

  * Add cross-compiling support.

 -- Colin Watson <cjwatson@debian.org>  Tue, 27 Sep 2011 14:29:27 +0100

putty (0.61-1) unstable; urgency=low

  * New upstream release.
  * Update Vcs-* fields for Alioth changes.

 -- Colin Watson <cjwatson@debian.org>  Wed, 13 Jul 2011 15:26:33 +0100

putty (0.60+2011-05-09-1) unstable; urgency=low

  * New experimental development snapshot.
    - Compiles cleanly with GCC 4.6 (closes: #625113, #625426).
  * Consistently capitalise SSH in the package description when referring to
    the protocol (closes: #610486).

 -- Colin Watson <cjwatson@debian.org>  Mon, 09 May 2011 13:45:39 +0100

=== debian/rules ===
--- 
+++ 
@@ -14,8 +14,17 @@
 verdef := VER=-DSNAPSHOT="$(version)"
 endif
 
+DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+
+ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
+cross :=
+else
+cross := CC=$(DEB_HOST_GNU_TYPE)-gcc
+endif
+
 override_dh_auto_build:
-	cd unix && $(MAKE) -f Makefile.gtk $(verdef) \
+	cd unix && $(MAKE) -f Makefile.gtk $(verdef) $(cross) \
 		plink pscp psftp pterm putty puttygen
 	$(MAKE) -C icons cicons pngs

## putty 0.62

=== macosx/Makefile ===
--- 
+++ 
@@ -174,7 +174,7 @@
 		uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o uxser.o \
 		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o 
 
-pscp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
+pscp: be_ssh.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
 		pinger.o portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o \
 		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
 		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
@@ -182,7 +182,7 @@
 		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
 		uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o uxsftp.o \
 		uxstore.o version.o wildcard.o x11fwd.o
-	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
+	$(CC) $(ULDFLAGS) -o $@ be_ssh.o cmdline.o cproxy.o int64.o \
 		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o pscp.o \
 		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
 		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
@@ -192,7 +192,7 @@
 		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
 		x11fwd.o 
 
-psftp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
+psftp: be_ssh.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
 		pinger.o portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o \
 		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
 		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
@@ -200,7 +200,7 @@
 		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
 		uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o uxsftp.o \
 		uxstore.o version.o wildcard.o x11fwd.o
-	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
+	$(CC) $(ULDFLAGS) -o $@ be_ssh.o cmdline.o cproxy.o int64.o \
 		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o \
 		psftp.o settings.o sftp.o ssh.o sshaes.o ssharcf.o \
 		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
@@ -236,6 +236,11 @@
 		../puttymem.h ../tree234.h ../windows/winhelp.h \
 		../charset/charset.h
 	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
+be_ssh.o: ../be_ssh.c ../putty.h ../puttyps.h ../network.h ../misc.h \
+		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
+		../puttymem.h ../tree234.h ../windows/winhelp.h \
+		../charset/charset.h
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \
 		../misc.h ../puttymem.h ../tree234.h ../int64.h \
 		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
@@ -246,8 +251,3 @@
 		../puttymem.h ../tree234.h ../windows/winhelp.h \
 		../charset/charset.h
 	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
-config.o: ../config.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
-		../network.h ../misc.h ../windows/winstuff.h ../macosx/osx.h \
-		../unix/unix.h ../puttymem.h ../tree234.h \
-		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<

=== debian/changelog ===
putty (0.62-9+deb7u3) wheezy-security; urgency=high

  * More robust control sequence parameter handling, including:
    - CVE-2015-5309: Fix a potentially memory-corrupting integer overflow in
      the handling of the ECH (erase characters) control sequence in the
      terminal emulator.

 -- Colin Watson <cjwatson@debian.org>  Sun, 29 Nov 2015 00:10:04 +0000

putty (0.62-9+deb7u2) stable-security; urgency=high

  * Backport from upstream:
    - MATTA-2015-002: Enforce acceptable range for Diffie-Hellman server
      value.
    - Fix an erroneous length field in SSH-1 key load.
    - CVE-2015-2157: Fix failure to clear sensitive private key information
      from memory (closes: #779488).

 -- Colin Watson <cjwatson@debian.org>  Sat, 14 Mar 2015 12:56:58 +0000

putty (0.62-9+deb7u1) stable-security; urgency=high

  * CVE-2013-4206: Buffer underrun in modmul could corrupt the heap.
  * CVE-2013-4852: Negative string length in public-key signatures could
    cause integer overflow and overwrite all of memory (closes: #718779).
  * CVE-2013-4207: Non-coprime values in DSA signatures can cause buffer
    overflow in modular inverse.
  * CVE-2013-4208: Private keys were left in memory after being used by
    PuTTY tools.
  * Backport some general proactive potentially-security-relevant tightening
    from upstream.

 -- Colin Watson <cjwatson@debian.org>  Wed, 07 Aug 2013 10:11:18 +0100

putty (0.62-9) unstable; urgency=low

  * Backport from upstream (Simon Tatham):
    - Fix handling of non-default numeric keypad modes when Num Lock is on
      (closes: #680261).

 -- Colin Watson <cjwatson@debian.org>  Thu, 23 Aug 2012 12:58:52 +0100

putty (0.62-8) unstable; urgency=low

  * Backport from upstream (Simon Tatham):
    - Support dead keys and compose sequences (closes: #221786, #250464).

 -- Colin Watson <cjwatson@debian.org>  Fri, 22 Jun 2012 15:18:51 +0100

putty (0.62-7) unstable; urgency=low

  * Add System category to pterm.desktop (closes: #678126).
  * Use dpkg-buildflags to enable hardening options.

 -- Colin Watson <cjwatson@debian.org>  Tue, 19 Jun 2012 13:28:15 +0100

putty (0.62-6) unstable; urgency=low

  * Backport from upstream (Simon Tatham, Jacob Nevins):
    - Generate keys more carefully, so that when the user asks for an n-bit
      key they always get an n-bit number instead of n-1.  The latter was
      perfectly harmless but kept confusing users (closes: #661152).

 -- Colin Watson <cjwatson@debian.org>  Sun, 04 Mar 2012 16:09:28 +0000

putty (0.62-5) unstable; urgency=low

  * Ignore failures to generate PNG icons too.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Feb 2012 19:51:39 +0000

putty (0.62-4) unstable; urgency=low

  * Ignore failures to generate XPM icons.  It's not the end of the world,
    and this fails on kFreeBSD due to some apparently undiagnosed
    imagemagick bug.
  * Drop icon-debug.patch, since it didn't especially help anyway.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Feb 2012 15:42:14 +0000

putty (0.62-3) unstable; urgency=low

  * Fix icon-debug.patch to print debug information to stderr, not stdout.

 -- Colin Watson <cjwatson@debian.org>  Tue, 03 Jan 2012 21:34:28 +0000

putty (0.62-2) unstable; urgency=low

  * Avoid deprecated GLib functions.
  * Add temporary debugging patch to try to figure out why the
    kfreebsd-amd64 build is failing.

 -- Colin Watson <cjwatson@debian.org>  Tue, 03 Jan 2012 18:14:45 +0000

putty (0.62-1) unstable; urgency=high

  * New upstream release.
    - [SECURITY] Wipe SSH keyboard-interactive replies from memory after
      authentication.

 -- Colin Watson <cjwatson@debian.org>  Mon, 12 Dec 2011 02:05:49 +0000

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.5.9
-Build-Depends: debhelper (>= 7.0.50), pkg-config, libgtk2.0-dev, x11proto-core-dev, libx11-dev, imagemagick, python
-Vcs-Bzr: http://bzr.debian.org/pkg-ssh/putty/trunk
-Vcs-Browser: http://bzr.debian.org/loggerhead/pkg-ssh/putty/trunk
+Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 7.0.50), pkg-config, libgtk2.0-dev, x11proto-core-dev, libx11-dev, imagemagick, python
+Vcs-Bzr: http://anonscm.debian.org/bzr/pkg-ssh/putty/trunk
+Vcs-Browser: http://anonscm.debian.org/loggerhead/pkg-ssh/putty/trunk
 
 Package: pterm
 Section: x11
@@ -14,7 +14,7 @@
 Suggests: putty-doc
 Provides: x-terminal-emulator
 Description: PuTTY terminal emulator
- This is an X terminal emulator based on the popular Windows ssh client,
+ This is an X terminal emulator based on the popular Windows SSH client,
  PuTTY. It supports xterm escape sequences, plus some Linux console
  sequences for colour palette configuration and some DECterm sequences for
  title bar control, and with an appropriate font it supports the UTF-8
@@ -26,7 +26,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, putty-tools
 Suggests: putty-doc
 Description: Telnet/SSH client for X
- This is the Unix port of the popular Windows ssh client, PuTTY. It supports
+ This is the Unix port of the popular Windows SSH client, PuTTY. It supports
  flexible terminal setup, mid-session reconfiguration using Ctrl-rightclick,
  multiple X11 authentication protocols, and various other interesting things
  not provided by ssh in an xterm.

=== debian/rules ===
--- 
+++ 
@@ -23,10 +23,15 @@
 cross := CC=$(DEB_HOST_GNU_TYPE)-gcc
 endif
 
+CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
+LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+
 override_dh_auto_build:
 	cd unix && $(MAKE) -f Makefile.gtk $(verdef) $(cross) \
+		XFLAGS="$(CPPFLAGS) $(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
 		plink pscp psftp pterm putty puttygen
-	$(MAKE) -C icons cicons pngs
+	-$(MAKE) -C icons cicons pngs
 
 override_dh_auto_clean:
 	cd unix && $(MAKE) -f Makefile.gtk clean
@@ -34,11 +39,11 @@
 
 override_dh_install:
 	dh_install
-	install -m644 icons/xpmpterm.c $(ptermtmp)/usr/share/pixmaps/pterm.xpm
-	install -m644 icons/xpmputty.c $(puttytmp)/usr/share/pixmaps/putty.xpm
-	install -m644 icons/pterm-32.png \
+	-install -m644 icons/xpmpterm.c $(ptermtmp)/usr/share/pixmaps/pterm.xpm
+	-install -m644 icons/xpmputty.c $(puttytmp)/usr/share/pixmaps/putty.xpm
+	-install -m644 icons/pterm-32.png \
 		      $(ptermtmp)/usr/share/pixmaps/pterm.png
-	install -m644 icons/putty-32.png \
+	-install -m644 icons/putty-32.png \
 		      $(puttytmp)/usr/share/pixmaps/putty.png
 
 override_dh_compress:

## putty 0.63

=== doc/Makefile ===
all: man index.html

# Decide on the versionid policy.
#
# If the user has passed in $(VERSION) on the command line (`make
# VERSION="Release 0.56"'), we use that as an explicit version
# string. Otherwise, we use `svnversion' to examine the checked-out
# documentation source, and if that returns a single revision
# number then we invent a version string reflecting just that
# number. Failing _that_, we resort to versionids.but which shows a
# $Id for each individual file.
#
# So here, we define VERSION using svnversion if it isn't already
# defined ...
ifndef VERSION
SVNVERSION=$(shell test -d .svn && svnversion .)
BADCHARS=$(findstring :,$(SVNVERSION))$(findstring S,$(SVNVERSION))
ifeq ($(BADCHARS),)
ifneq ($(SVNVERSION),)
ifneq ($(SVNVERSION),exported)
VERSION=Built from revision $(patsubst M,,$(SVNVERSION))
endif
endif
endif
endif
# ... and now, we condition our build behaviour on whether or not
# VERSION _is_ defined.
ifdef VERSION
VERSIONIDS=vstr
vstr.but: FORCE
	echo \\versionid $(VERSION) > vstr.but
FORCE:;
else
VERSIONIDS=vids
endif

CHAPTERS := $(SITE) blurb intro gs using config pscp psftp plink pubkey
CHAPTERS += pageant errors faq feedback licence udp pgpkeys sshnames
CHAPTERS += index $(VERSIONIDS)

INPUTS = $(patsubst %,%.but,$(CHAPTERS))

# This is temporary. Hack it locally or something.
HALIBUT = halibut

index.html: $(INPUTS)
	$(HALIBUT) --text --html --winhelp $(INPUTS)

# During formal builds it's useful to be able to build this one alone.
putty.hlp: $(INPUTS)
	$(HALIBUT) --winhelp $(INPUTS)

putty.info: $(INPUTS)
	$(HALIBUT) --info $(INPUTS)

chm: putty.hhp
putty.hhp: $(INPUTS) chm.but
	$(HALIBUT) --html $(INPUTS) chm.but

MKMAN = $(HALIBUT) --man=$@ mancfg.but $<
MANPAGES = putty.1 puttygen.1 plink.1 pscp.1 psftp.1 puttytel.1 pterm.1
man: $(MANPAGES)

putty.1: man-putt.but mancfg.but; $(MKMAN)
puttygen.1: man-pg.but mancfg.but; $(MKMAN)
plink.1: man-pl.but mancfg.but; $(MKMAN)
pscp.1: man-pscp.but mancfg.but; $(MKMAN)
psftp.1: man-psft.but mancfg.but; $(MKMAN)
puttytel.1: man-ptel.but mancfg.but; $(MKMAN)
pterm.1: man-pter.but mancfg.but; $(MKMAN)

mostlyclean:
	rm -f *.html *.txt *.hlp *.cnt *.1 *.info vstr.but *.hh[pck]
clean: mostlyclean
	rm -f *.chm

=== macosx/Makefile ===
--- 
+++ 
@@ -83,6 +83,11 @@
 #      Cygnus/mingw32, whose resource compiler may have less of a
 #      problem with it.
 #
+#  - COMPAT=-DNO_SECUREZEROMEMORY (Windows only)
+#      Disables PuTTY's use of SecureZeroMemory(), which is missing
+#      from some environments' header files.  This is enabled by
+#      default in the Cygwin Makefile.
+#
 #  - XFLAGS=-DTELNET_DEFAULT
 #      Causes PuTTY to default to the Telnet protocol (in the absence
 #      of Default Settings and so on to the contrary). Normally PuTTY
@@ -128,20 +133,21 @@
 		PuTTY.app/Contents/Resources/PuTTY.icns \
 		PuTTY.app/Contents/Info.plist $(PuTTY_extra)
 
-PuTTY.app/Contents/MacOS/PuTTY: PuTTY.app/Contents/MacOS be_all_s.o config.o \
-		cproxy.o dialog.o fromucs.o ldisc.o ldiscucs.o localenc.o \
-		logging.o macenc.o mimeenc.o minibidi.o misc.o osxctrls.o \
-		osxdlg.o osxmain.o osxsel.o osxwin.o pgssapi.o pinger.o \
-		portfwd.o proxy.o raw.o rlogin.o sbcs.o sbcsdat.o sercfg.o \
-		settings.o slookup.o ssh.o sshaes.o ssharcf.o sshblowf.o \
-		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
-		sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o \
-		sshsh512.o sshsha.o sshzlib.o telnet.o terminal.o testback.o \
-		time.o timing.o toucs.o tree234.o utf8.o ux_x11.o uxagentc.o \
-		uxcfg.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxprint.o \
-		uxproxy.o uxpty.o uxsel.o uxser.o uxsignal.o uxstore.o \
-		uxucs.o version.o wcwidth.o wildcard.o x11fwd.o xenc.o
-	$(CC) $(MLDFLAGS) -o $@ be_all_s.o config.o cproxy.o dialog.o \
+PuTTY.app/Contents/MacOS/PuTTY: PuTTY.app/Contents/MacOS be_all_s.o conf.o \
+		config.o cproxy.o dialog.o fromucs.o ldisc.o ldiscucs.o \
+		localenc.o logging.o macenc.o mimeenc.o minibidi.o misc.o \
+		osxctrls.o osxdlg.o osxmain.o osxsel.o osxwin.o pgssapi.o \
+		pinger.o portfwd.o proxy.o raw.o rlogin.o sbcs.o sbcsdat.o \
+		sercfg.o settings.o slookup.o ssh.o sshaes.o ssharcf.o \
+		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
+		sshdss.o sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
+		sshsh256.o sshsh512.o sshsha.o sshzlib.o telnet.o terminal.o \
+		testback.o time.o timing.o toucs.o tree234.o utf8.o ux_x11.o \
+		uxagentc.o uxcfg.o uxgss.o uxmisc.o uxnet.o uxnoise.o \
+		uxprint.o uxproxy.o uxpty.o uxsel.o uxser.o uxsignal.o \
+		uxstore.o uxucs.o version.o wcwidth.o wildcard.o x11fwd.o \
+		xenc.o
+	$(CC) $(MLDFLAGS) -o $@ be_all_s.o conf.o config.o cproxy.o dialog.o \
 		fromucs.o ldisc.o ldiscucs.o localenc.o logging.o macenc.o \
 		mimeenc.o minibidi.o misc.o osxctrls.o osxdlg.o osxmain.o \
 		osxsel.o osxwin.o pgssapi.o pinger.o portfwd.o proxy.o raw.o \
@@ -155,16 +161,16 @@
 		uxsel.o uxser.o uxsignal.o uxstore.o uxucs.o version.o \
 		wcwidth.o wildcard.o x11fwd.o xenc.o 
 
-plink: be_all_s.o cmdline.o cproxy.o ldisc.o logging.o misc.o pgssapi.o \
-		pinger.o portfwd.o proxy.o raw.o rlogin.o settings.o ssh.o \
-		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
-		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
-		sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o sshzlib.o \
-		telnet.o time.o timing.o tree234.o ux_x11.o uxagentc.o \
-		uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxplink.o \
-		uxproxy.o uxsel.o uxser.o uxsignal.o uxstore.o version.o \
-		wildcard.o x11fwd.o
-	$(CC) $(ULDFLAGS) -o $@ be_all_s.o cmdline.o cproxy.o ldisc.o \
+plink: be_all_s.o cmdline.o conf.o cproxy.o ldisc.o logging.o misc.o \
+		pgssapi.o pinger.o portfwd.o proxy.o raw.o rlogin.o \
+		settings.o ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o \
+		sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o sshgssc.o \
+		sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o \
+		sshsha.o sshzlib.o telnet.o time.o timing.o tree234.o \
+		ux_x11.o uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o \
+		uxnoise.o uxplink.o uxproxy.o uxsel.o uxser.o uxsignal.o \
+		uxstore.o version.o wildcard.o x11fwd.o
+	$(CC) $(ULDFLAGS) -o $@ be_all_s.o cmdline.o conf.o cproxy.o ldisc.o \
 		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o raw.o \
 		rlogin.o settings.o ssh.o sshaes.o ssharcf.o sshblowf.o \
 		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
@@ -174,7 +180,7 @@
 		uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o uxser.o \
 		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o 
 
-pscp: be_ssh.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
+pscp: be_ssh.o cmdline.o conf.o cproxy.o int64.o logging.o misc.o pgssapi.o \
 		pinger.o portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o \
 		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
 		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
@@ -182,7 +188,7 @@
 		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
 		uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o uxsftp.o \
 		uxstore.o version.o wildcard.o x11fwd.o
-	$(CC) $(ULDFLAGS) -o $@ be_ssh.o cmdline.o cproxy.o int64.o \
+	$(CC) $(ULDFLAGS) -o $@ be_ssh.o cmdline.o conf.o cproxy.o int64.o \
 		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o pscp.o \
 		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
 		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
@@ -192,7 +198,7 @@
 		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
 		x11fwd.o 
 
-psftp: be_ssh.o cmdline.o cproxy.o int64.o logging.o misc.o pgssapi.o \
+psftp: be_ssh.o cmdline.o conf.o cproxy.o int64.o logging.o misc.o pgssapi.o \
 		pinger.o portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o \
 		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
 		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
@@ -200,7 +206,7 @@
 		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
 		uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o uxsftp.o \
 		uxstore.o version.o wildcard.o x11fwd.o
-	$(CC) $(ULDFLAGS) -o $@ be_ssh.o cmdline.o cproxy.o int64.o \
+	$(CC) $(ULDFLAGS) -o $@ be_ssh.o cmdline.o conf.o cproxy.o int64.o \
 		logging.o misc.o pgssapi.o pinger.o portfwd.o proxy.o \
 		psftp.o settings.o sftp.o ssh.o sshaes.o ssharcf.o \
 		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
@@ -210,16 +216,16 @@
 		uxnoise.o uxproxy.o uxsel.o uxsftp.o uxstore.o version.o \
 		wildcard.o x11fwd.o 
 
-puttygen: cmdgen.o import.o misc.o notiming.o sshaes.o sshbn.o sshdes.o \
-		sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o sshrand.o \
-		sshrsa.o sshrsag.o sshsh256.o sshsh512.o sshsha.o time.o \
-		tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o uxstore.o \
-		version.o
-	$(CC) $(ULDFLAGS) -o $@ cmdgen.o import.o misc.o notiming.o sshaes.o \
-		sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o \
-		sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh256.o sshsh512.o \
-		sshsha.o time.o tree234.o uxcons.o uxgen.o uxmisc.o \
-		uxnoise.o uxstore.o version.o 
+puttygen: cmdgen.o conf.o import.o misc.o notiming.o sshaes.o sshbn.o \
+		sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o \
+		sshrand.o sshrsa.o sshrsag.o sshsh256.o sshsh512.o sshsha.o \
+		time.o tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o \
+		uxstore.o version.o
+	$(CC) $(ULDFLAGS) -o $@ cmdgen.o conf.o import.o misc.o notiming.o \
+		sshaes.o sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o \
+		sshprime.o sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh256.o \
+		sshsh512.o sshsha.o time.o tree234.o uxcons.o uxgen.o \
+		uxmisc.o uxnoise.o uxstore.o version.o 
 
 be_all_s.o: ../be_all_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
@@ -246,8 +252,3 @@
 		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
 		../windows/winhelp.h ../charset/charset.h
 	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
-cmdline.o: ../cmdline.c ../putty.h ../puttyps.h ../network.h ../misc.h \
-		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
-		../puttymem.h ../tree234.h ../windows/winhelp.h \
-		../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<

=== debian/changelog ===
putty (0.63-4) unstable; urgency=medium

  * Backport from upstream (Simon Tatham):
    - Fix assertion failure in Unix PuTTYgen exports (LP: #1289176).

 -- Colin Watson <cjwatson@debian.org>  Tue, 08 Apr 2014 12:19:08 +0100

putty (0.63-3) unstable; urgency=medium

  * Use dh-autoreconf, with the aid of a few upstream patches to make things
    work with current autotools.
  * Backport upstream patch to add some assertions in sshzlib.c, fixing
    build with -O3.

 -- Colin Watson <cjwatson@debian.org>  Wed, 12 Mar 2014 12:07:04 +0000

putty (0.63-2) unstable; urgency=low

  * Support parallel builds.
  * Switch to git; adjust Vcs-* fields.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Jan 2014 13:01:57 +0000

putty (0.63-1) unstable; urgency=low

  * New upstream release.
    - CVE-2013-4206: Buffer underrun in modmul could corrupt the heap.
    - CVE-2013-4852: Negative string length in public-key signatures could
      cause integer overflow and overwrite all of memory (closes: #718779).
    - CVE-2013-4207: Non-coprime values in DSA signatures can cause buffer
      overflow in modular inverse.
    - CVE-2013-4208: Private keys were left in memory after being used by
      PuTTY tools.
    - Allow using a bold colour and a bold font at the same time (closes:
      #193352).
    - Use a monotonic clock (closes: #308552).
  * Switch to the Autotools-based build system.
  * Upgrade to debhelper v9.

 -- Colin Watson <cjwatson@debian.org>  Wed, 07 Aug 2013 04:00:18 +0100

putty (0.62-11) unstable; urgency=low

  * Backport from upstream (Ben Harris, Simon Tatham):
    - Avoid function pointer comparison when using clang.

 -- Colin Watson <cjwatson@debian.org>  Tue, 04 Jun 2013 15:45:00 +0100

putty (0.62-10) unstable; urgency=low

  * Backport from upstream (Simon Tatham, closes: #701425):
    - Check the return values of setuid and friends.
    - Remove the half-hearted attempt to make the utmp helper process drop
      privileges just before dying of a fatal signal.

 -- Colin Watson <cjwatson@debian.org>  Mon, 25 Feb 2013 20:36:40 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #! /usr/bin/make -f
 %:
-	dh $@
+	dh $@ --with=autoreconf --parallel
 
 ptermtmp = debian/pterm
 puttytmp = debian/putty
@@ -14,27 +14,20 @@
 verdef := VER=-DSNAPSHOT="$(version)"
 endif
 
-DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
-DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+autoreconf:
+	./mkfiles.pl
+	autoreconf -fi
+	rm -rf autom4te.cache
 
-ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
-cross :=
-else
-cross := CC=$(DEB_HOST_GNU_TYPE)-gcc
-endif
-
-CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
-CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
-LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+override_dh_autoreconf:
+	dh_autoreconf debian/rules -- autoreconf
 
 override_dh_auto_build:
-	cd unix && $(MAKE) -f Makefile.gtk $(verdef) $(cross) \
-		XFLAGS="$(CPPFLAGS) $(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
-		plink pscp psftp pterm putty puttygen
+	dh_auto_build -- $(verdef)
 	-$(MAKE) -C icons cicons pngs
 
 override_dh_auto_clean:
-	cd unix && $(MAKE) -f Makefile.gtk clean
+	dh_auto_clean
 	$(MAKE) -C icons clean
 
 override_dh_install:

=== debian/watch ===
version=3
http://the.earth.li/~sgtatham/putty/latest/putty-(.*)\.tar\.gz

## putty 0.65

=== debian/changelog ===
putty (0.65-2) unstable; urgency=medium

  * Backport from upstream:
    - Performance: cache character widths returned from Pango (closes:
      #792258).

 -- Colin Watson <cjwatson@debian.org>  Sun, 23 Aug 2015 18:47:52 +0100

putty (0.65-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Tue, 28 Jul 2015 11:18:13 +0100

putty (0.64-1) unstable; urgency=medium

  * New upstream release.
    - Support sharing an SSH connection between multiple instances of PuTTY
      and its tools.
    - Add a command-line and config option to specify the expected host
      key(s).

 -- Colin Watson <cjwatson@debian.org>  Sun, 14 Jun 2015 11:03:52 +0100

putty (0.63-10) unstable; urgency=medium

  * Backport from upstream:
    - Make kh2reg.py compatible with modern Python.
    - MATTA-2015-002: Enforce acceptable range for Diffie-Hellman server
      value.
    - Fix an erroneous length field in SSH-1 key load.
    - CVE-2015-2157: Fix failure to clear sensitive private key information
      from memory (closes: #779488).

 -- Colin Watson <cjwatson@debian.org>  Sun, 01 Mar 2015 12:59:15 +0000

putty (0.63-9) unstable; urgency=medium

  * Backport from upstream (Simon Tatham):
    - Revert the default for font bolding style back to using colours rather
      than fonts (closes: #772948).

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Dec 2014 10:11:04 +0000

putty (0.63-8) unstable; urgency=medium

  * Backport from upstream (Simon Tatham), suggested by Jacob Nevins:
    - Fix incorrect handling of saved sessions with a dynamic SOCKS tunnel
      bound to a specific protocol (IPv4 or IPv6).

 -- Colin Watson <cjwatson@debian.org>  Sun, 12 Oct 2014 20:47:42 +0100

putty (0.63-7) unstable; urgency=medium

  * Build with all hardening options.  (Thanks, Markus.)

 -- Colin Watson <cjwatson@debian.org>  Sun, 24 Aug 2014 00:29:36 +0100

putty (0.63-6) unstable; urgency=medium

  * Backport two upstream patches to fix runaway timer explosions (closes:
    #758473).

 -- Colin Watson <cjwatson@debian.org>  Wed, 20 Aug 2014 21:05:52 +0100

putty (0.63-5) unstable; urgency=medium

  * Backport from upstream (Simon Tatham):
    - Fix an annoying timer-handling warning from current versions of GTK.

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Apr 2014 21:57:57 +0100
